unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, Grids, mFileList, StdCtrls, IdAntiFreezeBase, IdAntiFreeze,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    mFileList1: TmFileList;
    IdHTTP1: TIdHTTP;
    IdAntiFreeze1: TIdAntiFreeze;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdHTTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure IdHTTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    DlTime: cardinal;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  TheStream: TMemoryStream;
begin
  TheStream:= TMemoryStream.Create;
  try
    IdHTTP1.Get('http://hem.passagen.se/matasp/mfilelisttest.txt', TheStream);
  finally
    TheStream.Free;
  end;
end;

procedure TForm1.IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
var
  Speed: string;
begin
  if DLTime > 0 then
    Speed:= FormatFloat('0', (AWorkCount / 1024) / DlTime);
  mFileList1.Progress(0, AWorkCount, 1489164, '', Speed, '');
end;

procedure TForm1.IdHTTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
  mFileList1.Progress(0, -1, -1,'','','Ready.');
end;

procedure TForm1.IdHTTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  mFileList1.Progress(-1,0,0,'http://hem.passagen.se/matasp/filelisttest.txt','0','Downloading...');
  Timer1.Enabled:= true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Inc(DLTime);
end;

end.
